#pragma pack(1)

#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <map>

#include "OnigRegex.h"
#include "OutputDebugStream.h"

using namespace std;


// K\}b`Op̊֐
// @str_target

int OnigMatch( string str_target, string str_regex, Matches* pmatches) {

	// ܂Aʂ͍폜
	if ( pmatches ) {
		pmatches->clear();
	}

	// ǂ炩gȂAfalseԂB
	if ( str_target.length() == 0 || str_regex.length() == 0 ) {
		return false;
	}

	int r;
	OnigUChar *start, *range, *end;
	regex_t* reg;
	OnigErrorInfo einfo;
	OnigRegion *region;

	UChar* pattern = (UChar* )str_regex.c_str(); // "(.+?)()|[-]+";
	UChar* str     = (UChar* )str_target.c_str(); // "\x0A\x0A";

	// K\̍쐬B SJIS
	r = onig_new(&reg, pattern, pattern + strlen((char* )pattern),
		ONIG_OPTION_MULTILINE, ONIG_ENCODING_SJIS, ONIG_SYNTAX_DEFAULT, &einfo);

	if (r != ONIG_NORMAL) {
		char s[ONIG_MAX_ERROR_MESSAGE_LEN];
		onig_error_code_to_str((OnigUChar *)s, r, &einfo);
		OutputDebugStream("K\RpCG[: %s\n", s);
		return false;
	}

	region = onig_region_new();

	end   = str + strlen((char* )str);
	start = str;
	range = end;

	// K\ŌB
	r = onig_search(reg, str, end, start, range, region, ONIG_OPTION_NONE);
	if (r >= 0) {
		int i;

		// }b`ŜƁA( )̒g̕\B
		// fprintf(stderr, "match at %d\n", r);
		for (i = 0; i < region->num_regs; i++) {

			if ( pmatches ) {
				int len = region->end[i]-region->beg[i];
				// Rs[邽߂̗̈𓮓IɊm
				char *cp = new char[len+1]; // ŏƍŌ̍mہBendP߂Ȃ̂ŁANULLmۂĂB

				// Rs[
				// @@@@@@Rs[Jnʒu      Rs[oCg
				strncpy( cp, (char *)(str)+region->beg[i], len );
				cp[len] = '\0'; // ŌNULLB

				// OutputDebugStream("%s", cp);
				pmatches->insert( Matches::value_type( i, cp ) );

				// IȊmۗ̈
				delete [] cp;
			}
		}
	}
	else if (r == ONIG_MISMATCH) {
		// OutputDebugStream("search fail\n");
	}
	else { /* error */
		char s[ONIG_MAX_ERROR_MESSAGE_LEN];
		onig_error_code_to_str((OnigUChar *)s, r);
		OutputDebugStream("K\}b`sG[: %s\n", s);
		return false;
	}

	onig_region_free(region, 1 /* 1:free self, 0:free contents only */);
	onig_free(reg);

	if ( r >= 0 ) {
		return true;
	} else {
		return false;
	}
}
